// GMenu.h: interface for the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GMENU_H__67921400_3F05_11D4_8F75_C0DCED0EBB18__INCLUDED_)
#define AFX_GMENU_H__67921400_3F05_11D4_8F75_C0DCED0EBB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GRun.h"

#include "inifile.h"
extern st_inifile ini;

extern BITMAP *b_menu;

class GMenu  
{
public:
	void Destroy(GRun *run);
	void LoadGFX(GRun *run);
	int Col(int index);
	bool Run(GRun *run);
	GMenu();
	virtual ~GMenu();

private:
	bool ProccesKeys();
	void Draw();
	int  m_item;

	int  m_maxplay;

	bool m_konec;


	GRun *m_run;

	char m_buf[50];

	enum {
		it_com = 0,
		it_ipx, 
		it_tcpip,
		it_single,
		it_nastaveni,
		it_konec
	};
};

#endif // !defined(AFX_GMENU_H__67921400_3F05_11D4_8F75_C0DCED0EBB18__INCLUDED_)
