// GMenuBack.cpp: implementation of the GMenuBack class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenuBack.h"

BITMAP *b_menu;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GMenuBack::GMenuBack()
{
}

GMenuBack::~GMenuBack()
{

}

void GMenuBack::Flip()
{
	hscreen.Flip();
	m_back = hscreen.m_back;
}

void GMenuBack::FadeOut()
{
	return;
}

bool GMenuBack::LoadGFX()
{
	if (!(b_menu = hload_bitmap("gfx\\other\\menu.jpg"))) {
		allegro_message("Missing file gfx\\other\\menu.jpg");
		return false;
	}

	m_back = hscreen.m_back;

	return true;
}

void GMenuBack::Destroy()
{
	if (b_menu != NULL) destroy_bitmap(b_menu);
	b_menu = NULL;
}

void GMenuBack::Clear()
{
	draw_sprite(m_back, b_menu, 0, 0);
}

void GMenuBack::Acquire()
{
	acquire_bitmap(m_back);
}

void GMenuBack::Release()
{
	release_bitmap(m_back);
}
