// GRun.h: interface for the GRun class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _G_RUN_INCLUDE_
#define _G_RUN_INCLUDE_

#include "GClasses.h"
#include "GSoldier.h"
#include "GView.h"
#include "GMap.h"
#include "GNet.h"
#include "CDPlayer.h"



class GRun  // hlavni trida hry - MUZE BYT JEN JEDNA INSTANCE TETO TRIDY !!!!!!!
{
public:
	void MoveDemo();
	void InitDemo();
	void ProcessKeys();
	void CompMove();
	bool Init(int id, int mapa);
	void InitSingle(int players);
	void Crash();
	void Move();
	void Draw();
	bool NewRace(char *file );
	bool LoadGFX();
	void Destroy();
	bool LoadBitmaps(BITMAP **pole, int kolik, int zacatek, char *file); 
	void Run();
	GRun();
	virtual ~GRun();

	GView     m_view;                 // kamera
	GSoldier  m_sold[MAX_PLAYERS];      // vojaci
	GMap      m_map;                   // mapa objektu
	GNet      m_net;

	int       m_soldiers;              // pocet vojaku
	int       m_monsol;                // index monitorovaneho vojaka

	DWORD     m_game_speed;            // urcuje rychlost hry v milisekundach

	bool    m_stin;						// zda se maji kreslit i stiny
	bool    m_autorun;

	bool    m_server;	// zda je tento hrac ve hre server
	bool    m_multi;  // zda bezi multi player

	// nastavovaci promene
	int     m_maxstrel;    // zba po smrti vojak dostane kolik % vybaveni
	bool    m_doruststrel; // zda probiha dorustani strel
};

#endif // #ifndef _G_RUN_INCLUDE_
