// GStrela.h: interface for the GStrela class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GSTRELA_H__194F7A40_3464_11D4_8F75_B0131965891D__INCLUDED_)
#define AFX_GSTRELA_H__194F7A40_3464_11D4_8F75_B0131965891D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GClasses.h"
#include "zbrane.h"

class GStrela  
{
public:
	bool Hit(int x, int y, int dst);
	int  GetDemage(GMap  *map);
	void Draw(int CX, int CY, bool light);
	void Move(GMap *map);
	void Init(int x, int y, int angle, int ID, int who, double speed, int zbranID);
	GStrela();
	virtual ~GStrela();

	bool m_active;
	int m_x;
	int m_y;
	int m_ox;
	int m_oy;
	double m_angleRad;
	int  m_angle;
	int  m_ID;
	int  m_who;  // seznam jiz trefenych panacku (viz exploze)
	double m_speed;

	int m_dist; // polomer ucinnosti

	RECT m_rect;  // obdelnik poskozeni
};

#endif // !defined(AFX_GSTRELA_H__194F7A40_3464_11D4_8F75_B0131965891D__INCLUDED_)
