
#ifndef _H_SCREEN_
#define _H_SCREEN_

#include <allegro.h>

#define H_SCREEN_NOINIT  0
#define H_SCREEN_2PAGES  1
#define H_SCREEN_BUFFER  2

class HScreen  
{
public:
	void SaveScreen(bool small, char *file);
	void Destroy();
	int Flip(bool VSYNC = false);
	bool Init(int w = 640, int h = 480, int bpp = 16, int card = GFX_AUTODETECT);

	int GetStav();
	BITMAP* GetVisible(); // viditelna   stranka
	BITMAP* m_back;       // neviditelna stranka
	HScreen();
	virtual ~HScreen();

	/// aby se pokazdy nemuselo volat to sileny makro
	int  m_w; // sirka obrazovky
	int  m_h; // vyska obrazovky 
	bool m_mouse;  // je - li true, pri flipingu se navic kresli i mys - neimplementovano :(

protected:
   BITMAP *m_page1, *m_page2; // dve stranky na page flipping
	BITMAP *m_buffer;          // pokud se nazdari, pouziva se 1 zadni buffer
	int     m_stav;
	int     m_saves;           // pocet ulozeni do souboru

	DWORD   m_last;            // pro pocitani fps
	double  m_fps;             // frames per second
private:
	void Repare();
	void ToBack();
};

#endif // #ifndef _H_SCREEN_
