// SetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Setup.h"
#include "SetupDlg.h"
#include "..\inifile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg dialog

CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_hudba = FALSE;
	m_hudba_vol = 0;
	m_zvuky = FALSE;
	m_zvuky_vol = 0;
	m_ip = _T("");
	m_cd = FALSE;
	m_autorun = FALSE;
	m_zamerovac = FALSE;
	m_effects = FALSE;
	m_seffects = FALSE;
	m_meffects = FALSE;
	m_mrtvol = 0;
	m_antialiasing = FALSE;
	m_nesmrt = FALSE;
	m_fps = FALSE;
	m_feffects = FALSE;
	m_sensitive = 0;
	m_sensit = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	dat.bpp = 0; dat.com = 0; dat.com_speed = 0;
	dat.hudba = 1; dat.hudba_vol = 125; dat.ip[0] = '\0';
	dat.zvuky = 1; dat.zvuky_vol = 125;
	dat.jmeno[0] = '\0'; dat.mapa = 1; dat.pocitacu = 10;
	dat.postava = 0; dat.svetlo = 1;
	dat.effects = true; dat.seffects = true;
	dat.ovladani = 1; dat.meffects = true;
	dat.flipmode = 1; dat.mrtvol = 100;
	dat.antialaising = true; dat.resolution = 0;
	dat.nesmrt = false; dat.fps = false; dat.feffect = false;
	dat.turnsen = 10.0;
}

void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Control(pDX, IDC_ROZLISENI, m_rozliseni);
	DDX_Control(pDX, IDC_FLIPMODE, m_flipmode);
	DDX_Control(pDX, IDC_CONTROL, m_control);
	DDX_Control(pDX, IDC_RYCHLOST, m_rychlost);
	DDX_Control(pDX, IDC_COM, m_com);
	DDX_Control(pDX, IDC_BPP, m_bpp);
	DDX_Check(pDX, IDC_HUDBA, m_hudba);
	DDX_Slider(pDX, IDC_HUDBA_VOL, m_hudba_vol);
	DDX_Check(pDX, IDC_ZVUKY, m_zvuky);
	DDX_Slider(pDX, IDC_ZVUKY_VOL, m_zvuky_vol);
	DDX_Text(pDX, IDC_IP, m_ip);
	DDX_Check(pDX, IDC_CD, m_cd);
	DDX_Check(pDX, IDC_AUTORUN, m_autorun);
	DDX_Check(pDX, IDC_ZAMEROVAC, m_zamerovac);
	DDX_Check(pDX, IDC_EFFECTS, m_effects);
	DDX_Check(pDX, IDC_SEFFECTS, m_seffects);
	DDX_Check(pDX, IDC_MEFFECTS, m_meffects);
	DDX_Text(pDX, IDC_MRTVOL, m_mrtvol);
	DDV_MinMaxInt(pDX, m_mrtvol, 0, 10000);
	DDX_Check(pDX, IDC_ANTIALIAS, m_antialiasing);
	DDX_Check(pDX, IDC_NESMRT, m_nesmrt);
	DDX_Check(pDX, IDC_FPS, m_fps);
	DDX_Check(pDX, IDC_FEFFECTS, m_feffects);
	DDX_Slider(pDX, IDC_SENSITIVE, m_sensitive);
	DDX_Text(pDX, IDC_SENS_TEXT, m_sensit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SENSITIVE, OnReleasedcaptureSensitive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg message handlers

BOOL CSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	((CSliderCtrl*)GetDlgItem(IDC_ZVUKY_VOL))->SetRange(0,255,TRUE);
	((CSliderCtrl*)GetDlgItem(IDC_HUDBA_VOL))->SetRange(0,255,TRUE);
	((CSliderCtrl*)GetDlgItem(IDC_SENSITIVE))->SetRange(10, 200,TRUE);
	
	// TODO: Add extra initialization here
	LoadData();
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSetupDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSetupDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSetupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSetupDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();
	SaveData();
	CDialog::OnOK();
}

void CSetupDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CSetupDlg::SaveData()
{
	CFile file;
	if (!file.Open(INIFILE, CFile::typeBinary | CFile::modeWrite  |CFile::modeCreate)) {
		MessageBox("Neni mozne otevrit/vytvorit soubor !", "Writing error.",MB_ICONSTOP|MB_OK);
		return;
	}

	dat.bpp   =  m_bpp.GetCurSel();
	dat.com   =  m_com.GetCurSel();
	dat.hudba =  m_hudba;
	dat.zvuky =  m_zvuky;
	dat.cd    =  m_cd;
	dat.fps   =  m_fps;
	dat.zamerovac  =  m_zamerovac;
	dat.autorun    =  m_autorun;
	dat.antialaising = m_antialiasing;
	dat.com_speed  =  m_rychlost.GetCurSel();
	dat.zvuky_vol  =  m_zvuky_vol;
	dat.hudba_vol  =  m_hudba_vol;
	dat.ovladani   =  m_control.GetCurSel();
	dat.effects    =  m_effects;
	dat.seffects   =  m_seffects;
	dat.meffects   =  m_meffects;
	dat.feffect    =  m_feffects;
	dat.flipmode   =  m_flipmode.GetCurSel();
	dat.resolution =  m_rozliseni.GetCurSel();
	dat.mrtvol     =  m_mrtvol;
	dat.nesmrt     =  m_nesmrt;
	dat.turnsen    =  m_sensitive/10.0;
 	strcpy(dat.ip, m_ip);

	file.Write(&dat, sizeof(dat));
	file.Close();
}

void CSetupDlg::LoadData()
{
	CFile file;
	if (file.Open(INIFILE, CFile::typeBinary | CFile::modeRead)) {
		file.Read(&dat, sizeof(dat));
		file.Close();
	}

	m_bpp.SetCurSel(dat.bpp);
	m_com.SetCurSel(dat.com);
	m_control.SetCurSel(dat.ovladani);
	m_flipmode.SetCurSel(dat.flipmode);
	m_hudba = dat.hudba;
	m_zvuky = dat.zvuky;
	m_rychlost.SetCurSel(dat.com_speed);
	m_rozliseni.SetCurSel(dat.resolution);
	m_zvuky_vol =  dat.zvuky_vol ;
	m_hudba_vol =  dat.hudba_vol ;
	m_sensitive =  dat.turnsen*10;
 	m_ip.Format("%s",dat.ip);
	m_cd        = dat.cd;
	m_fps       = dat.fps;
	m_zamerovac = dat.zamerovac;
	m_autorun   = dat.autorun;
	m_antialiasing = dat.antialaising;
	m_effects   = dat.effects;
	m_seffects  = dat.seffects;
	m_meffects  = dat.meffects;
	m_feffects  = dat.feffect;
	m_mrtvol    = dat.mrtvol;
	m_nesmrt    = dat.nesmrt;

	m_sensit= m_sensitive/10.0;

}

void CSetupDlg::OnAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CSetupDlg::OnReleasedcaptureSensitive(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	m_sensit= m_sensitive/10.0;
	UpdateData(FALSE);
	
	*pResult = 0;
}
