
#include <time.h> // pro random
#include "stdh.h"

#include "soldiers.h"
#include "objects.h"

// Gincludes
#include "GClasses.h"
#include "GRun.h"
#include "GView.h"
#include "GFile.h"
#include "GObject.h"
#include "GMap.h"

#include "MultiPlay.h"

#include "GMenu.h"

// globalni unikatni identifikator vytvorny pomoci GuidGen
// {FE9BFFA2-3BDB-11d4-8F75-B86292AF3253}
GUID guid = 
{ 0xfe9bffa2, 0x3bdb, 0x11d4, { 0x8f, 0x75, 0xb8, 0x62, 0x92, 0xaf, 0x32, 0x53 } };


void timer_procedure()
{
	if (tmr > 0) tmr--;
}

END_OF_FUNCTION(timer_procedure);



int main(int argc, char *argv[])
{
	int  i;
	char c[50];

   allegro_init();
   install_keyboard();
	install_timer();
	install_mouse();

	set_mouse_speed(20, 20);


	// pripraveni timeru
	LOCK_VARIABLE(tmr);
	LOCK_FUNCTION(timer_procedure);
	install_int(timer_procedure, 10);
 
	net = new NDX_Connect;
	if (net == NULL) {
		allegro_message("new NDX_Connect"); // SMULA !!!!
		return 2;
	}

	if (!net->Create(&guid)) {
		allegro_message("chyba GUID"); // SMULA !!!!
		return 2;
	}

	srand(time(NULL));
	DF_X = 640;
	DF_Y = 480;

	if (!hscreen.Init(640, 480,16)) // zkusime 16BPP
		if (!hscreen.Init(DF_X, DF_Y,15 )) {  // tak to zkusime v 15BPP
		   set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
			allegro_message("Nepodarilo se nastavit rozliseni \n %d*%d*16 ani %d*%d*15 !!!", DF_X, DF_Y, DF_X, DF_Y); // SMULA !!!!
			return 1;
		}

	PALETTE pal;

	for (i = 0 ; i < MAX_MOUSE_CUR; i++) {
		sprintf( c,"mys%d.bmp",i);
		b_mouse[i] = load_bitmap(c, pal);
	}

//	freeze_mouse_flag = 1;

	set_mouse_sprite(NULL);

//	show_mouse(hscreen.m_back);

	hscreen.m_mouse = false;

	hscreen.Flip();

	GRun run; // promena typu GRun musi byt jen jedna !!!!!!

// HLAVNI HERNI SMYCKA
	GMenu menu;
	while (menu.Run(&run)) {
		if (run.Init()) {
			run.Run();
			run.Destroy();
			run.m_net.ShutDown();
			net->Create(&guid);
		}
	}
// KONEC HLAVNI SMYCKY 

	run.Destroy();

	hscreen.Destroy();

	show_mouse(NULL);
	for (i = 0 ; i < MAX_MOUSE_CUR; i++)
	   destroy_bitmap(b_mouse[i]);

	delete net;
	net = NULL;

	allegro_exit();

   return 0;
}

END_OF_MAIN();
