// GMenu.h: interface for the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GMENU_H__67921400_3F05_11D4_8F75_C0DCED0EBB18__INCLUDED_)
#define AFX_GMENU_H__67921400_3F05_11D4_8F75_C0DCED0EBB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GRun.h"

#include "inifile.h"
extern st_inifile ini;

extern BITMAP *b_menu;

class GMenu  
{
public:
	void Destroy(GRun *run);
	void LoadGFX(GRun *run);
	int Col(int index);
	bool Run(GRun *run);
	GMenu();
	virtual ~GMenu();

	int  m_postava;
	int  m_mapa;

private:
	bool ProccesKeys(GRun *run);
	void Draw(char *name);
	int  m_item;

	int  m_maxplay;
	int  m_angle;  // uhel postavy (toci se dokola)

	bool m_konec;

	int  m_map;

	char m_buf[50];

	enum {
		it_jmeno = 0,
		it_com,
		it_ipx, 
		it_tcpip,
		it_single,
		it_mapa,
		it_konec
	};
};

#endif // !defined(AFX_GMENU_H__67921400_3F05_11D4_8F75_C0DCED0EBB18__INCLUDED_)
