#ifndef _INIFILE_INCLUDE_
#define _INIFILE_INCLUDE_

#define INIFILE  "kulic.cfg"

#define CTRL_KEYB     0
#define CTRL_KEYMOUS  1

typedef struct {
// nastaveni obecne
	int   bpp;
	int   zvuky;
	int   zvuky_vol;
	int   hudba;
	int   hudba_vol;
	int   com;
	int   com_speed;
	char  ip[50];

	bool  cd; // zda ma byt hudba z cd

// vlastni
	int   ovladani;

// nastaveni pro menu
	int   postava;
	char  jmeno[60];
	int   mapa;
	int   pocitacu;
	bool  autorun;
	bool  zamerovac; 
	int   svetlo;   // hra noc/den; 1 == den, 2 == noc
	bool  effects;  // ruzne efekty (svetlo)
	bool  seffects; // efekty obrazovky (FadeDown a FadeUp)
	bool  meffects; // efekty menu (vlneni)

// nastaveni hry
	bool  killme;   // typ chovani pocitacu
	bool  flipmode; // typ page flippingu
	int   mrtvol;   // pocet mrtvol, kdy se prekresli obrazovka
	int   resolution; // rozliseni pri hre 0 == 640*480;  1 = 320*240
	bool  antialaising; // povoleni pouzivani anti-aliasingu
	bool  nesmrt;   // docasna nesmrtelnost pri oziveni

	bool  fps;  // zda se maji zobrazovat framy za sekundu
	bool  feffect; // efekty prolinani jednotlivych obrazovek v menu

	double turnsen; // jemnost toceni

// nastaveni ve hre
	int minAI;  // minimalni inteligence
	int maxAI;  // maximalni inteligence

} st_inifile;



#endif // _INIFILE_INCLUDE_